import { IMessageQuestion } from "./types";
import { Label } from "./label";
import { Serializeable } from "./serializeable";

export class Question implements IMessageQuestion, Serializeable {
   private _QNAME = new Label();
   get QNAME() { return this._QNAME.name };

   _QTYPE: number;
   get QTYPE() { return this._QTYPE };

   _QCLASS: number;
   get QCLASS() { return this._QCLASS };

   constructor(question: IMessageQuestion) {
      this._QCLASS = question.QCLASS;
      this._QTYPE = question.QTYPE;
      this._QNAME.name = question.QNAME;
   }

   lock() {
      let name = this._QNAME.lock();
      let type = this._QTYPE;
      let cl = this._QCLASS;
      return {
         length: name.length + 4,
         serialize: (buffer: Buffer, offset: number) => {
            offset = name.serialize(buffer, offset);
            buffer.writeUInt16BE(type, offset);
            offset += 2;
            buffer.writeUInt16BE(cl, offset);
            offset += 2;
            return offset;
         }
      }
   }
}